package com.foo.emptypostapp.client;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;

public class Client {

    private static final String ENTITY = initiate();

    private static String initiate() {
        StringBuilder b = new StringBuilder();
        for (int i = 0; i < 100; i++) {
            b.append("The quick brown fox jumped over the lazy dog\n");
        }
        return b.toString();
    }

    public static void main(String[] args) throws Exception {
        testServlet();
        testJersey();
    }

    public static void testServlet() throws Exception {
        URL u = new URL("http://localhost:8080/EmptyPostApp/Servlet");
        test(u);
    }

    public static void testJersey() throws Exception {
        URL u = new URL("http://localhost:8080/EmptyPostApp/Jersey/");
        test(u);
    }

    public static void test(URL u) throws Exception {
        try {
            testByteHttpUrlConnection(u, ENTITY.getBytes(), false);
            testByteHttpUrlConnection(u, ENTITY.getBytes(), true);
        } catch (RuntimeException ex) {
            ex.printStackTrace();
        }
    }

    public static void testByteHttpUrlConnection(URL u, byte[] b, boolean setLength) throws Exception {
        for (int i = 0; i < 1000; i++) {
            String s = _testByteHttpUrlConnection(u, b, setLength);
            System.out.println(i + ": '" + s + "'");
            if (s.length() == 0) {
                throw new RuntimeException("Empty response for " + u);
            }
        }
    }

    public static String _testByteHttpUrlConnection(URL u, byte[] b, boolean setLength) throws Exception {
        HttpURLConnection c = (HttpURLConnection)u.openConnection();

        c.setDoInput(true);
        c.setDoOutput(true);
        if (setLength) {
            c.setFixedLengthStreamingMode(b.length);
        }
        c.setRequestProperty("Content-Length", "application/octet-stream");

        c.getOutputStream().write(b);

        InputStream in = c.getInputStream();

        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        byte[] buf = new byte[1024];
        int read;
        while ((read = in.read(buf)) != -1) {
            baos.write(buf, 0, read);
        }

        String s = new String(baos.toByteArray());
        in.close();
        return s;
    }
}